package examples.tls;

import java.io.*;
import java.util.*;
import javax.sip.*;
import javax.sip.address.*;
import javax.sip.header.*;
import javax.sip.message.*;
import java.util.*;



/**
 * This class is a UAC template. Shootist is the guy that shoots and shootme 
 * is the guy that gets shot.
 *
 *@author Daniel Martinez
 */

public class Shootist implements SipListener {

	private static SipProvider tlsProvider, sipProvider;
	private static AddressFactory addressFactory;
	private static MessageFactory messageFactory;
	private static HeaderFactory headerFactory;
	private static SipStack sipStack;
	private int reInviteCount;
	private ContactHeader contactHeader;
	private ListeningPoint tlsListeningPoint;

	Shootist listener;
	protected ClientTransaction registerTid;
	protected ClientTransaction inviteTid;
	protected ServerTransaction optionsTid;

	protected static final String usageString =
		"ant tlsshootist \n";

		// If you want to try TCP transport change the following to
		String transport = "tls";
//		String peerHost = "192.168.1.112";
		String peerHost = "132.194.22.188";
		String peerPort = "5061";
		String peerHostPort = peerHost + ":" + peerPort;
		String myIPAddress = "192.168.1.110";

	private static void usage() {
		System.out.println(usageString);
		System.exit(0);

	}
	private void shutDown() {
		try {
		        try {  
					Thread.sleep(2000);
		     	} catch (InterruptedException e) {
		     	}
			System.out.println("nulling reference");
			sipStack.deleteListeningPoint(tlsListeningPoint);
			// This will close down the stack and exit all threads
			tlsProvider.removeSipListener(this);
			while (true) {
			  try {
			      sipStack.deleteSipProvider(tlsProvider);
			      break;
			    } catch (ObjectInUseException  ex)  {
			        try {  
						Thread.sleep(2000);
			     	} catch (InterruptedException e) {
						continue;
			     	}
			   }
			}
			sipStack = null;
			tlsProvider = null;
			this.registerTid = null;
			this.inviteTid = null;
			this.contactHeader = null;
			addressFactory = null;
			headerFactory = null;
			messageFactory = null;
			this.tlsListeningPoint = null;
			this.reInviteCount = 0;
			System.gc();
		} catch (Exception ex) { ex.printStackTrace(); }
	}
	
	public void processRequest(RequestEvent requestReceivedEvent) {
		Request request = requestReceivedEvent.getRequest();
		ServerTransaction serverTransactionId =
			requestReceivedEvent.getServerTransaction();

		System.out.println(
			"\n\nRequest "
				+ request.getMethod()
				+ " received at "
				+ sipStack.getStackName()
				+ " with server transaction id "
				+ serverTransactionId);

		// We are the UAC so the only request we get is the BYE.
		if (request.getMethod().equals(Request.BYE))
			processBye(request, serverTransactionId);
		else if (request.getMethod().equals(Request.INVITE))
			processInvite(request, serverTransactionId);
		else if (request.getMethod().equals(Request.OPTIONS))
			processOptions(request, serverTransactionId);
	}

	public void processBye(Request request, ServerTransaction serverTransactionId) {
		try {
			System.out.println("shootist:  got a bye .");
			if (serverTransactionId == null) {
				System.out.println("shootist:  null TID.");
				return;
			}
			Dialog dialog = serverTransactionId.getDialog();
			System.out.println("Dialog State = " + dialog.getState());
			Response response = messageFactory.createResponse
						(200, request);
			serverTransactionId.sendResponse(response);
			System.out.println("shootist:  Sending OK.");
			System.out.println("Dialog State = " + dialog.getState());

//			this.shutDown();

		} catch (Exception ex) {
			ex.printStackTrace();
			System.exit(0);
		}
	}

	public void processInvite(Request request, ServerTransaction serverTransactionId) {
		try {
			System.out.println("shootist:  got a INVITE");
			if (serverTransactionId == null) {
				System.out.println("shootist:  null TID.");
				return;
			}
//			Dialog dialog = serverTransactionId.getDialog();
//			System.out.println("Dialog State = " + dialog.getState());
			Response response = messageFactory.createResponse
						(200, request);
			serverTransactionId.sendResponse(response);
			System.out.println("shootist:  Sending Response OK.");
//			System.out.println("Dialog State = " + dialog.getState());

		} catch (Exception ex) {
			ex.printStackTrace();
			System.exit(0);
		}
	}

	public void processOptions(Request request, ServerTransaction serverTransactionId) {
		try {
			System.out.println("shootist:  got a OPTIONS");
			Response response = messageFactory.createResponse(200, request);
			if (serverTransactionId == null) {
				System.out.println("shootist:  null TID.");
				optionsTid = sipProvider.getNewServerTransaction(request);
//				return;
			}
//			Dialog dialog = serverTransactionId.getDialog();
//			System.out.println("Dialog State = " + dialog.getState());

			optionsTid.sendResponse(response);
			System.out.println("shootist:  Sending Response OK.");
//			System.out.println("Dialog State = " + dialog.getState());

		} catch (Exception ex) {
			ex.printStackTrace();
			System.exit(0);
		}
	}
	
	public void processResponse(ResponseEvent responseReceivedEvent) {
		System.out.println("Got a response");
		Response response = (Response) responseReceivedEvent.getResponse();
		Transaction tid = responseReceivedEvent.getClientTransaction();

		System.out.println(
			"Response received with client transaction id "
				+ tid
				+ ":\n"
				+ response.getStatusCode());
		if (tid == null) {
			System.out.println("Stray response -- dropping ");
			return;
		}
		System.out.println("transaction state is " + tid.getState());
		System.out.println("Dialog = " + tid.getDialog());
			

		try {
			if (response.getStatusCode() == Response.OK
				&& ((CSeqHeader) response.getHeader(CSeqHeader.NAME))
					.getMethod().equals(Request.REGISTER)) {
	
		//		Dialog dialog = tid.getDialog();
		//		Request ackRequest = dialog.createRequest(Request.ACK);
		//		System.out.println("Sending ACK");
		//		dialog.sendAck(ackRequest);

				try {Thread.sleep(1000); } catch (Exception ex) {}
				
			}
			else if (response.getStatusCode() == Response.OK
				&& ((CSeqHeader) response.getHeader(CSeqHeader.NAME))
					.getMethod().equals(Request.INVITE)) {
				
				System.out.println("Dialog State is " + tid.getDialog().getState());
				
				// Request cancel = inviteTid.createCancel();
				// ClientTransaction ct = 
				//	sipProvider.getNewClientTransaction(cancel);
				// ct.sendRequest();
				Dialog dialog = tid.getDialog();
				Request ackRequest = dialog.createRequest(Request.ACK);
				System.out.println("Sending ACK");
				dialog.sendAck(ackRequest);

				// Send a Re INVITE but this time force it 
				// to use UDP as the transport. Else, it will
				// Use whatever transport was used to create
				// the dialog.
		/*		if (reInviteCount == 0) {
				    Request inviteRequest = 
					dialog.createRequest(Request.INVITE);
				    ((SipURI)inviteRequest.getRequestURI()).removeParameter("transport");
				    ((ViaHeader)inviteRequest.getHeader(ViaHeader.NAME)).setTransport("tls");
				    inviteRequest.addHeader(contactHeader);
				    try {Thread.sleep(100); } catch (Exception ex) {} 
				    ClientTransaction ct = 
					tlsProvider.getNewClientTransaction(inviteRequest);
				    dialog.sendRequest(ct);
				    reInviteCount ++;
				}*/
			}
		} catch (Exception ex) {
			ex.printStackTrace();
			System.exit(0);
		}
	}

	public void processTimeout(javax.sip.TimeoutEvent timeoutEvent) {

		System.out.println("Transaction Time out" );
	}

	public void init() {
		SipFactory sipFactory = null;
		sipStack = null;
		sipFactory = SipFactory.getInstance();
		sipFactory.setPathName("gov.nist");
		Properties properties = new Properties();

		properties.setProperty("javax.sip.IP_ADDRESS", "192.168.1.110");
		properties.setProperty(
			"javax.sip.OUTBOUND_PROXY", 
			peerHostPort + "/" + transport);
		// If you want to use UDP then uncomment this.
		//properties.setProperty(
		//	"javax.sip.ROUTER_PATH",
		//	"examples.shootistTLS.MyRouter");
		properties.setProperty("javax.sip.STACK_NAME", "shootist");
		properties.setProperty("javax.sip.RETRANSMISSION_FILTER", "on");

		// The following properties are specific to nist-sip
		// and are not necessarily part of any other jain-sip
		// implementation.
		// You can set a max message size for tcp transport to 
		// guard against denial of service attack.
		properties.setProperty("gov.nist.javax.sip.MAX_MESSAGE_SIZE", "1048576");
		properties.setProperty("gov.nist.javax.sip.DEBUG_LOG", "shootistdebug.txt");
		properties.setProperty("gov.nist.javax.sip.SERVER_LOG", "shootistlog.txt");

		// Drop the client connection after we are done with the transaction.
		properties.setProperty("gov.nist.javax.sip.CACHE_CLIENT_CONNECTIONS", "false");
		// Set to 0 in your production code for max speed.
		// You need  16 for logging traces. 32 for debug + traces.
		// Your code will limp at 32 but it is best for debugging.
		properties.setProperty("gov.nist.javax.sip.TRACE_LEVEL", "16");

		try {
			// Create SipStack object
			sipStack = sipFactory.createSipStack(properties);
			System.out.println("createSipStack " + sipStack);
		} catch (PeerUnavailableException e) {
			// could not find
			// gov.nist.jain.protocol.ip.sip.SipStackImpl
			// in the classpath
			e.printStackTrace();
			System.err.println(e.getMessage());
			System.exit(0);
		}

		try {
			headerFactory = sipFactory.createHeaderFactory();
			addressFactory = sipFactory.createAddressFactory();
			messageFactory = sipFactory.createMessageFactory();
			listener = this;

			tlsListeningPoint = sipStack.createListeningPoint(5061, "tls");
			tlsProvider = sipStack.createSipProvider(tlsListeningPoint);
			tlsProvider.addSipListener(listener);

			sipProvider = tlsProvider;
		} catch (Exception ex) {
			System.out.println(ex.getMessage());
			ex.printStackTrace();
			usage();
		}
	}
	
	public void Register() {
		try {
			String fromName = "voipuser1";
			String fromSipAddress = peerHost; //"here.com";
			String fromDisplayName = "Shootist";

			String toSipAddress = peerHost; //"there.com";
			String toUser = "voipuser1";
			String toDisplayName = "Shootist";

			// create >From Header
			SipURI fromAddress =
				addressFactory.createSipURI(fromName, fromSipAddress);

			Address fromNameAddress = addressFactory.createAddress(fromAddress);
			fromNameAddress.setDisplayName(fromDisplayName);
			FromHeader fromHeader =
				headerFactory.createFromHeader(fromNameAddress, "12345");

			// create To Header
			SipURI toAddress =
				addressFactory.createSipURI(toUser, toSipAddress);
			Address toNameAddress = addressFactory.createAddress(toAddress);
			toNameAddress.setDisplayName(toDisplayName);
			ToHeader toHeader =
				headerFactory.createToHeader(toNameAddress, null);

			// create Request URI
			SipURI requestURI =
				addressFactory.createSipURI(null, peerHostPort);

			// Create ViaHeaders
			ArrayList viaHeaders = new ArrayList();
			int port = sipProvider.getListeningPoint().getPort();
			ViaHeader viaHeader =
				headerFactory.createViaHeader(
					sipStack.getIPAddress(),
					sipProvider.getListeningPoint().getPort(),
					transport,
					null);

			// add via headers
			viaHeaders.add(viaHeader);

			// Create a new MaxForwardsHeader
			MaxForwardsHeader maxForwards =
				headerFactory.createMaxForwardsHeader(70);

			// Create a new CallId header
			CallIdHeader callIdHeader = sipProvider.getNewCallId();

			// Create contact headers
			String host = sipStack.getIPAddress();
			
			// Create the contact name address.
			SipURI contactUrl = addressFactory.createSipURI(fromName, host);
			contactUrl.setPort(tlsListeningPoint.getPort());
			SipURI contactURI = addressFactory.createSipURI(fromName, host);
			contactURI.setPort(sipProvider.getListeningPoint().getPort());

			Address contactAddress = addressFactory.createAddress(contactURI);

			// Add the contact address.
			contactAddress.setDisplayName(fromName);

			contactHeader =
				headerFactory.createContactHeader(contactAddress);
				
			CSeqHeader cSeqHeader =
				headerFactory.createCSeqHeader(1, Request.REGISTER);

			// Create the request.
			Request request =
				messageFactory.createRequest(
					requestURI,
					Request.REGISTER,
					callIdHeader,
					cSeqHeader,
					fromHeader,
					toHeader,
					viaHeaders,
					maxForwards);
			
			request.addHeader(contactHeader);
			
			// Create the client transaction.
			listener.registerTid = sipProvider.getNewClientTransaction(request);

			// send the request out.
			listener.registerTid.sendRequest();

		} catch (Exception ex) {
			System.out.println(ex.getMessage());
			ex.printStackTrace();
			usage();
		}
	}

	public void Invite(String peer) {
		Shootist listener = this;
		
		try {
			String fromName = "voipuser1";
			String fromSipAddress = peerHost; //"here.com";
			String fromDisplayName = "Shootist";

			String toSipAddress = peerHost; //"there.com";
			String toUser = peer; //"20002";
			String toDisplayName = "Xlite Home2";

			// create >From Header
			SipURI fromAddress =
				addressFactory.createSipURI(fromName, fromSipAddress);

			Address fromNameAddress = addressFactory.createAddress(fromAddress);
			fromNameAddress.setDisplayName(fromDisplayName);
			FromHeader fromHeader =
				headerFactory.createFromHeader(fromNameAddress, "12345");

			// create To Header
			SipURI toAddress =
				addressFactory.createSipURI(toUser, toSipAddress);
			Address toNameAddress = addressFactory.createAddress(toAddress);
			toNameAddress.setDisplayName(toDisplayName);
			ToHeader toHeader =
				headerFactory.createToHeader(toNameAddress, null);

			// create Request URI
			SipURI requestURI =
				addressFactory.createSipURI(toUser, peerHostPort);

			// Create ViaHeaders
			ArrayList viaHeaders = new ArrayList();
			int port = sipProvider.getListeningPoint().getPort();
			ViaHeader viaHeader =
				headerFactory.createViaHeader(
					sipStack.getIPAddress(),
					sipProvider.getListeningPoint().getPort(),
					transport,
					null);

			// add via headers
			viaHeaders.add(viaHeader);

			// Create a new MaxForwardsHeader
			MaxForwardsHeader maxForwards =
				headerFactory.createMaxForwardsHeader(70);
				
			// Create contact headers
			String host = sipStack.getIPAddress();
			
			// Create the contact name address.
			SipURI contactUrl = addressFactory.createSipURI(fromName, host);
			contactUrl.setPort(tlsListeningPoint.getPort());
			SipURI contactURI = addressFactory.createSipURI(fromName, host);
			contactURI.setPort(sipProvider.getListeningPoint().getPort());

			Address contactAddress = addressFactory.createAddress(contactURI);

			// Add the contact address.
			contactAddress.setDisplayName(fromName);

			contactHeader =
				headerFactory.createContactHeader(contactAddress);
				
			// Create a new CallId header
			CallIdHeader callIdHeader = sipProvider.getNewCallId();
							
			// Create a new Cseq header
			CSeqHeader cSeqHeader =
				headerFactory.createCSeqHeader(1, Request.INVITE);

			// Create the request.
			Request request =
				messageFactory.createRequest(
					requestURI,
					Request.INVITE,
					callIdHeader,
					cSeqHeader,
					fromHeader,
					toHeader,
					viaHeaders,
					maxForwards);

			request.addHeader(contactHeader);

			String sdpData =
				"v=0\r\n"
					+ "o=4855 13760799956958020 13760799956958020"
					+ " IN IP4  "+myIPAddress+"\r\n"
					+ "s=mysession session\r\n"
					+ "p=+46 8 52018010\r\n"
					+ "c=IN IP4  "+myIPAddress+"\r\n"
					+ "t=0 0\r\n"
					+ "m=audio 6022 RTP/AVP 0 4 18\r\n"
					+ "a=rtpmap:0 PCMU/8000\r\n"
					+ "a=rtpmap:4 G723/8000\r\n"
					+ "a=rtpmap:18 G729A/8000\r\n"
					+ "a=ptime:20\r\n";
			byte[] contents = sdpData.getBytes();

			// Create ContentTypeHeader
			ContentTypeHeader contentTypeHeader =
				headerFactory.createContentTypeHeader("application", "sdp");
			request.setContent(contents, contentTypeHeader);

			// Create the client transaction.
			listener.inviteTid = sipProvider.getNewClientTransaction(request);

			// send the request out.
			listener.inviteTid.sendRequest();

		} catch (Exception ex) {
			System.out.println(ex.getMessage());
			ex.printStackTrace();
			usage();
		}
	}

	void shell() {
		String cmd="hjlee", arg0="arg0";
		StringTokenizer stok=null;
		BufferedReader in = 
					new BufferedReader (new InputStreamReader(System.in), 1);
		String input = null;
			
		while (!cmd.equals("quit")) {
			// get user command and process it
			System.out.print("<shell>");
			try {
				input = in.readLine();
			} catch (IOException ex) {
//				System.out.println("IOException: "+ex.getMessage());
			}
			
			try {
				stok = new StringTokenizer(input);
				cmd = stok.nextToken();
				
			} catch (Exception e) {
//				System.out.println("Exception"+e.getMessage());
				continue;
			}
			
			if (cmd.equals("quit"))
				break;
			if (cmd.equals("invite")) {
				arg0 = stok.nextToken();
				Invite(arg0);	// Send a INVITE();
			}
			else if (cmd.equals("register")) {
				Register();
		//		arg0 = stok.nextToken();
		//		put(arg0);
			}
			else
				System.out.println(cmd+" is not supported!");
		}
		System.out.println("Exiting ---- Bye !");
		return;
	}
	
	public static void main(String args[]) {
	//	new Shootist().init();
		Shootist shootist = new Shootist();
		shootist.init();
		shootist.Register();
		shootist.shell();  // start command processing shell
		
		shootist.shutDown();
	}
}
